/* ======================================================================
 *
 * This grammar is based on the ANTLR grammar from ANTLR distribution.
 *
 * ======================================================================
 */

header {
package satc.lang;
}

{
import java.io.*;
import satc.antlr.DocParser;
}

/* ANTLR Translator Generator
 * Project led by Terence Parr at http://www.jGuru.com
 * Software rights: http://www.antlr.org/RIGHTS.html
 *
 * $Id: ANTLRParser.g,v 1.5 2003/11/29 00:57:14 bogdan Exp $
 */

class ANTLRParser extends Parser;//(DocParser);
options {
    importVocab = ANTLRLexer;
    exportVocab = ANTLR;
//    defaultErrorHandler = false;
    k = 1;
	buildAST = true;
}

tokens {
	GRAMMAR="grammar";
	RULE="rule";
	RULES="rules";
}

{
	public void insert( String key) {
		System.out.println("key = " + key);
	}

	public void insertActionFirst( Token a) {
		System.out.println("insert in action first: " + a);

	}
	public void insertActionLast( Token a) {
		System.out.println("insert in action last: " + a);
	}
	public void insertHeader( Token h) {
		System.out.println("insert in header: " + h);

	}

}

start : grammar ;
 
grammar
	:	header_
		( classDef )*
		EOF!
		{ ## = #([GRAMMAR,"grammar"], ##) ; }
	;

header_
	: 	h:"header"^	(n:STRING_LITERAL)? a:ACTION //{ insertHeader(h); }
	|	//{ insertHeader(null); }
	;

classDef
    :   ( a:ACTION )?
		"class"!
        id:ID   
        "extends"! ("Lexer"^ | "Parser"^ | "TreeParser"^)
        SEMI!
		( optionsSpec )?
		( tokensSpec )?
		( ACTION )?
		rules
		( ACTION )?
    ;

optionsSpec
    :   "options"^ LCURLY
        (   ("importVocab") => "importVocab" EQUAL! idi:ID   
        |   ("exportVocab") => "exportVocab" EQUAL! ide:ID   
        |   (~(RCURLY))!
        )*
        RCURLY
    ;

//FIXME
tokensSpec
	:	"tokens"^ ACTION 
	;

rules
    :   ( rule )+  
	{ ## = #([RULES,"rules"], ##) ; }
    ;

rule:
	(	p1:"protected"
	|	p2:"public"		
	|	p3:"private"	
	)?
	( BANG )?
	ID^ 
	( EXCL )?
	(a:ACTION )?
	COLON! block SEMI!
	;

block
    :   alternative ( OR! alternative )*  
		{ ## = #([OR,"block"], ##) ; }
    ;

alternative
    :	( EXCL )?
		( element )* 
    ;

element
	:	elementNoOptionSpec //(elementOptionSpec)?
	;

elementNoOptionSpec
	:	terminal ( EXCL )? 
	|	ebnf
	;

terminal
	:	CHAR_LITERAL
	|	ID 
	|	STRING_LITERAL
	|	DOT
	;

ebnf
	:	lp:LPAREN!
		(
			// 2nd alt and optional branch ambig due to
			// linear approx LL(2) issue.  COLON ACTION
			// matched correctly in 2nd alt.
			options {
				warnWhenFollowAmbig = false;
			}
		:
			//subruleOptionsSpec
			( aa:ACTION )?
			COLON
		|	ab:ACTION 
			COLON
		)?

		block
		RPAREN!

		(	(	QUESTION^
			|	STAR^	
			|	PLUS^	
			)?
			( EXCL^ )?
		|
			IMPLIES^	
		)
	;
