header {
package satc.lang; 
}

{
import java.io.*;
}

class VerilogTreeParser extends TreeParser;

options {
    buildAST=true;
}



start
    : 	#( START ( unit | directive )* )
    ;

unit: 	module
	| 	macromodule
    | 	udp
	;

module 
    : 	#("module" ID portList (element)* )		
    ;

portList 
    : 	#( PORT_LIST (identifier)* )
    ;

element
	: 	parameterDeclaration 
    | 	inputDeclaration 
    | 	outputDeclaration 
    | 	inoutDeclaration 
    | 	netDeclaration 
    | 	regDeclaration 
//    | 	timeDeclaration 
//    | 	integerDeclaration 
//    | 	realDeclaration 
//    | 	eventDeclaration 
//    | 	gateDeclaration 
//    | 	instantiation 
//    | 	parameterOverride 
    | 	continuousAssign  
//    | 	specifyBlock 
//    | 	initialStatement 
    | 	alwaysStatement 
//    | 	task
//    | 	function
//    | 	directive
    ;

/*------ Declarations ------*/

parameterDeclaration           
    : 	#("parameter" (range)? parameterAssignmentList )
    ;

parameterAssignmentList 
	:   (parameterAssignment)+
    ;

parameterAssignment 
	:   #( ASSIGN identifier expression )
    ;

inputDeclaration                               
    : 	#("input" (range)? inputList )
    ;

outputDeclaration                               
    : 	#("output" (range)? outputList )
    ;

inoutDeclaration                               
    : 	#("inout" (range)? inoutList )
    ;

inputList
    : id1:identifier (id2:identifier)*
    ;

outputList
    : id1:identifier (id2:identifier)*
    ;

inoutList
    : id1:identifier (id2:identifier)*
    ;






expression
	:	identifier
	;

range 
	:	#(RANGE simpleExpression simpleExpression)
    ;

simpleExpression
	:	#(SL simpleExpression simpleExpression)
	|	#(SR simpleExpression simpleExpression)
	|	#(PLUS simpleExpression simpleExpression)
	|	#(MINUS simpleExpression simpleExpression)
	|	#(STAR simpleExpression simpleExpression)
	|	#(DIV simpleExpression simpleExpression)
	|	#(MOD simpleExpression simpleExpression)
	|	#(UNARY_PLUS simpleExpression)
	|	#(UNARY_MINUS simpleExpression)
	|	identifier
	|	NUMBER
	;


identifier 
	:	IDENTIFIER
    |   ESCAPED_IDENTIFIER
    ;

////////////////////////////////////
netDeclaration	:	NIL6	;
regDeclaration	:	NIL7	;

continuousAssign	:	NIL4	;
alwaysStatement	:	NIL5	;

directive: NIL3 ;

macromodule: NIL ;
udp: NIL2 ;